#!/usr/bin/env python3
import os
import sys

def tlog_tar():
    print(os.system("date"))
    print("---------Start Running----------------")
    LOG_PATH = os.getcwd()
    print("---------Decompression File Start----------------")
    temp = os.listdir(LOG_PATH)
    for file in temp:
        if file.endswith(".tar.gz"):
            filename = os.path.basename(file)
            fname = os.path.splitext(filename)[0]
            fname = os.path.splitext(fname)[0]
            os.makedirs(os.path.join(LOG_PATH, fname), exist_ok=True)
            os.system(f"tar -zxvf {file} -C {os.path.join(LOG_PATH, fname)}")
    LOG_PATHS = os.path.join(LOG_PATH, fname) + "/"
    print(f"LOG_PATHS={LOG_PATHS}")
    temps = os.listdir(LOG_PATHS)
    for file in temps:
        if file.endswith(".tar.gz"):
            filename = os.path.basename(file)
            fname = os.path.splitext(filename)[0]
            os.makedirs(os.path.join(LOG_PATHS, fname), exist_ok=True)
            os.system(f"tar -zxvf {file} -C {os.path.join(LOG_PATHS, fname)}")
    print("---------Decompression End----------------")

def tlog_merge():
    output_dir = "out"
    if os.path.exists(output_dir):
        os.system(f"rm -rf {output_dir}/*")
    else:
        os.makedirs(output_dir, exist_ok=True)

    files = []
    for root, dirs, filenames in os.walk("."):
        for filename in filenames:
            if "persist" in filename and "log" in filename:
                files.append(os.path.join(root, filename))
    files.sort()
    for file in files:
        if file.endswith(".ing"):
            boot_number = file[-42:-36]
        else:
            boot_number = file[-38:-32]
        output_file = f"{boot_number}_merged_logcat_file.log"
        if os.path.exists(output_file):
            print(output_file)
        else:
            open(output_file, "w").close()
        with open(file, "r") as f:
            with open(output_file, "a") as out:
                out.write(f.read())

    files = []
    for root, dirs, filenames in os.walk("."):
        for filename in filenames:
            if "kernel" in filename and "log" in filename:
                files.append(os.path.join(root, filename))
    files.sort()
    for file in files:
        if file.endswith(".ing"):
            boot_number = file[-41:-35]
        else:
            boot_number = file[-37:-31]
        output_file = f"{boot_number}_merged_kernel_file.log"
        if os.path.exists(output_file):
            print(output_file)
        else:
            open(output_file, "w").close()
        with open(file, "r") as f:
            with open(output_file, "a") as out:
                out.write(f.read())

    merged_files = [f for f in os.listdir() if f.endswith("_merged_logcat_file.log") or f.endswith("_merged_kernel_file.log")]
    for fullname in merged_files:
        if os.path.getsize(fullname) > 104857600:
            with open(fullname, "rb") as f:
                data = f.read()
                i = 1
                while data:
                    chunk = data[:100*1024*1024]
                    data = data[100*1024*1024:]
                    with open(f"{fullname}({i}).{fullname.split('.')[-1]}", "wb") as out:
                        out.write(chunk)
                    i += 1
    os.system(f"mv *.log {output_dir}/")
    print("End merge")

tlog_tar()
tlog_merge()
print("The merged files are located in the out directory")
sys.exit(0)
